Skip to main content
Version: 1.22.0

Swift Package Registry

Publish Swift packages for your user or organization.

Requirements

To work with the Swift package registry, you need to use swift to consume and a HTTP client (like curl) to publish packages.

Configuring the package registry

To register the package registry and provide credentials, execute:

swift package-registry set https://gitea.example.com/api/packages/{owner}/swift
swift package-registry login https://gitea.example.com/api/packages/{owner}/swift --username {username} --password {password}
PlaceholderDescription
ownerThe owner of the package.
usernameYour Gitea username.
passwordYour Gitea password. If you are using 2FA or OAuth use a personal access token instead of the password.

The login is optional and only needed if the package registry is private.

Publish a package

First you have to pack the contents of your package:

swift package archive-source

To publish the package perform a HTTP PUT request with the package content in the request body.

curl -X PUT --user {username}:{password} \
-H "Accept: application/vnd.swift.registry.v1+json" \
-F source-archive=@/path/to/package.zip \
-F metadata={metadata} \
https://gitea.example.com/api/packages/{owner}/swift/{scope}/{name}/{version}
PlaceholderDescription
usernameYour Gitea username.
passwordYour Gitea password. If you are using 2FA or OAuth use a personal access token instead of the password.
ownerThe owner of the package.
scopeThe package scope.
nameThe package name.
versionThe package version.
metadata(Optional) The metadata of the package. JSON encoded subset of https://schema.org/SoftwareSourceCode

You cannot publish a package if a package of the same name and version already exists. You must delete the existing package first.

The server responds with the following HTTP Status codes.

HTTP Status CodeMeaning
201 CreatedThe package has been published.
400 Bad RequestThe package is invalid.
409 ConflictA package file with the same combination of parameters exists already.

Install a package

To install a Swift package from the package registry, add it in the Package.swift file dependencies list:

dependencies: [
.package(id: "{scope}.{name}", from:"{version}")
]
ParameterDescription
scopeThe package scope.
nameThe package name.
versionThe package version.

Afterwards execute the following command to install it:

swift package resolve